
module advanceddelegate.adelegate;

private import advanceddelegate.base;

class AdvancedDelegateP0G0(R) : AdvancedDelegate0!(R)
{
    alias R delegate() DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval() { return dg(); }
}

class AdvancedDelegateP1G0(R, P1) : AdvancedDelegate1!(R, P1)
{
    alias R delegate(P1) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1) { return dg(p1); }
    AdvancedDelegate0!(R) opCall(P1 p1) { return new AdvancedDelegateP1G1!(R, P1)(dg, p1); }
}

class AdvancedDelegateP1G1(R, P1) : AdvancedDelegate0!(R)
{
    alias R delegate(P1) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval() { return dg(p1); }
}

class AdvancedDelegateP2G0(R, P1, P2) : AdvancedDelegate2!(R, P1, P2)
{
    alias R delegate(P1, P2) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2) { return dg(p1, p2); }
    AdvancedDelegate1!(R, P2) opCall(P1 p1) { return new AdvancedDelegateP2G1!(R, P1, P2)(dg, p1); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP2G2!(R, P1, P2)(dg, p1, p2); }
}

class AdvancedDelegateP2G1(R, P1, P2) : AdvancedDelegate1!(R, P2)
{
    alias R delegate(P1, P2) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2) { return dg(p1, p2); }
    AdvancedDelegate0!(R) opCall(P2 p2) { return new AdvancedDelegateP2G2!(R, P1, P2)(dg, p1, p2); }
}

class AdvancedDelegateP2G2(R, P1, P2) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval() { return dg(p1, p2); }
}

class AdvancedDelegateP3G0(R, P1, P2, P3) : AdvancedDelegate3!(R, P1, P2, P3)
{
    alias R delegate(P1, P2, P3) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate2!(R, P2, P3) opCall(P1 p1) { return new AdvancedDelegateP3G1!(R, P1, P2, P3)(dg, p1); }
    AdvancedDelegate1!(R, P3) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP3G2!(R, P1, P2, P3)(dg, p1, p2); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedDelegateP3G1(R, P1, P2, P3) : AdvancedDelegate2!(R, P2, P3)
{
    alias R delegate(P1, P2, P3) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate1!(R, P3) opCall(P2 p2) { return new AdvancedDelegateP3G2!(R, P1, P2, P3)(dg, p1, p2); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedDelegateP3G2(R, P1, P2, P3) : AdvancedDelegate1!(R, P3)
{
    alias R delegate(P1, P2, P3) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P3 p3) { return new AdvancedDelegateP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedDelegateP3G3(R, P1, P2, P3) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval() { return dg(p1, p2, p3); }
}

class AdvancedDelegateP4G0(R, P1, P2, P3, P4) : AdvancedDelegate4!(R, P1, P2, P3, P4)
{
    alias R delegate(P1, P2, P3, P4) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P2, P3, P4) opCall(P1 p1) { return new AdvancedDelegateP4G1!(R, P1, P2, P3, P4)(dg, p1); }
    AdvancedDelegate2!(R, P3, P4) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP4G2!(R, P1, P2, P3, P4)(dg, p1, p2); }
    AdvancedDelegate1!(R, P4) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedDelegateP4G1(R, P1, P2, P3, P4) : AdvancedDelegate3!(R, P2, P3, P4)
{
    alias R delegate(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P3, P4) opCall(P2 p2) { return new AdvancedDelegateP4G2!(R, P1, P2, P3, P4)(dg, p1, p2); }
    AdvancedDelegate1!(R, P4) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedDelegateP4G2(R, P1, P2, P3, P4) : AdvancedDelegate2!(R, P3, P4)
{
    alias R delegate(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P4) opCall(P3 p3) { return new AdvancedDelegateP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedDelegateP4G3(R, P1, P2, P3, P4) : AdvancedDelegate1!(R, P4)
{
    alias R delegate(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P4 p4) { return new AdvancedDelegateP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedDelegateP4G4(R, P1, P2, P3, P4) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval() { return dg(p1, p2, p3, p4); }
}

class AdvancedDelegateP5G0(R, P1, P2, P3, P4, P5) : AdvancedDelegate5!(R, P1, P2, P3, P4, P5)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P2, P3, P4, P5) opCall(P1 p1) { return new AdvancedDelegateP5G1!(R, P1, P2, P3, P4, P5)(dg, p1); }
    AdvancedDelegate3!(R, P3, P4, P5) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP5G2!(R, P1, P2, P3, P4, P5)(dg, p1, p2); }
    AdvancedDelegate2!(R, P4, P5) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP5G1(R, P1, P2, P3, P4, P5) : AdvancedDelegate4!(R, P2, P3, P4, P5)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P3, P4, P5) opCall(P2 p2) { return new AdvancedDelegateP5G2!(R, P1, P2, P3, P4, P5)(dg, p1, p2); }
    AdvancedDelegate2!(R, P4, P5) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP5G2(R, P1, P2, P3, P4, P5) : AdvancedDelegate3!(R, P3, P4, P5)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P4, P5) opCall(P3 p3) { return new AdvancedDelegateP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP5G3(R, P1, P2, P3, P4, P5) : AdvancedDelegate2!(R, P4, P5)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P5) opCall(P4 p4) { return new AdvancedDelegateP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP5G4(R, P1, P2, P3, P4, P5) : AdvancedDelegate1!(R, P5)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P5 p5) { return new AdvancedDelegateP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP5G5(R, P1, P2, P3, P4, P5) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval() { return dg(p1, p2, p3, p4, p5); }
}

class AdvancedDelegateP6G0(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate6!(R, P1, P2, P3, P4, P5, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate5!(R, P2, P3, P4, P5, P6) opCall(P1 p1) { return new AdvancedDelegateP6G1!(R, P1, P2, P3, P4, P5, P6)(dg, p1); }
    AdvancedDelegate4!(R, P3, P4, P5, P6) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP6G2!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G1(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate5!(R, P2, P3, P4, P5, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate4!(R, P3, P4, P5, P6) opCall(P2 p2) { return new AdvancedDelegateP6G2!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G2(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate4!(R, P3, P4, P5, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P3 p3) { return new AdvancedDelegateP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G3(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate3!(R, P4, P5, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P5, P6) opCall(P4 p4) { return new AdvancedDelegateP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G4(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate2!(R, P5, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P6) opCall(P5 p5) { return new AdvancedDelegateP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G5(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate1!(R, P6)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P6 p6) { return new AdvancedDelegateP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP6G6(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6); }
}

class AdvancedDelegateP7G0(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate7!(R, P1, P2, P3, P4, P5, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate6!(R, P2, P3, P4, P5, P6, P7) opCall(P1 p1) { return new AdvancedDelegateP7G1!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1); }
    AdvancedDelegate5!(R, P3, P4, P5, P6, P7) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP7G2!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G1(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate6!(R, P2, P3, P4, P5, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate5!(R, P3, P4, P5, P6, P7) opCall(P2 p2) { return new AdvancedDelegateP7G2!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G2(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate5!(R, P3, P4, P5, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P3 p3) { return new AdvancedDelegateP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G3(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate4!(R, P4, P5, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P4 p4) { return new AdvancedDelegateP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G4(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate3!(R, P5, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P6, P7) opCall(P5 p5) { return new AdvancedDelegateP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P5 p5, P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G5(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate2!(R, P6, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P7) opCall(P6 p6) { return new AdvancedDelegateP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G6(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate1!(R, P7)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P7 p7) { return new AdvancedDelegateP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP7G7(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedDelegateP8G0(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate8!(R, P1, P2, P3, P4, P5, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate7!(R, P2, P3, P4, P5, P6, P7, P8) opCall(P1 p1) { return new AdvancedDelegateP8G1!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1); }
    AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP8G2!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G1(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate7!(R, P2, P3, P4, P5, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8) opCall(P2 p2) { return new AdvancedDelegateP8G2!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G2(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P3 p3) { return new AdvancedDelegateP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G3(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate5!(R, P4, P5, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P4 p4) { return new AdvancedDelegateP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G4(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate4!(R, P5, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P5 p5) { return new AdvancedDelegateP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P5 p5, P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G5(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate3!(R, P6, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate2!(R, P7, P8) opCall(P6 p6) { return new AdvancedDelegateP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P6 p6, P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G6(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate2!(R, P7, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P8) opCall(P7 p7) { return new AdvancedDelegateP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G7(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate1!(R, P8)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P8 p8) { return new AdvancedDelegateP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP8G8(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedDelegateP9G0(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate8!(R, P2, P3, P4, P5, P6, P7, P8, P9) opCall(P1 p1) { return new AdvancedDelegateP9G1!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1); }
    AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP9G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G1(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate8!(R, P2, P3, P4, P5, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9) opCall(P2 p2) { return new AdvancedDelegateP9G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G2(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P3 p3) { return new AdvancedDelegateP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G3(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P4 p4) { return new AdvancedDelegateP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G4(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate5!(R, P5, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P5 p5) { return new AdvancedDelegateP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P5 p5, P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G5(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate4!(R, P6, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P6 p6) { return new AdvancedDelegateP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P6 p6, P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G6(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate3!(R, P7, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate2!(R, P8, P9) opCall(P7 p7) { return new AdvancedDelegateP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P7 p7, P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G7(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate2!(R, P8, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate1!(R, P9) opCall(P8 p8) { return new AdvancedDelegateP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P8 p8, P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G8(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate1!(R, P9)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval(P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P9 p9) { return new AdvancedDelegateP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP9G9(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedDelegateP10G0(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate9!(R, P2, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1) { return new AdvancedDelegateP10G1!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1); }
    AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2) { return new AdvancedDelegateP10G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedDelegateP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G1(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate9!(R, P2, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P2 p2) { return new AdvancedDelegateP10G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3) { return new AdvancedDelegateP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedDelegateP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G2(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P3 p3) { return new AdvancedDelegateP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P3 p3, P4 p4) { return new AdvancedDelegateP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedDelegateP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G3(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P4 p4) { return new AdvancedDelegateP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P4 p4, P5 p5) { return new AdvancedDelegateP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G4(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P5 p5) { return new AdvancedDelegateP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P5 p5, P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G5(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate5!(R, P6, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P6 p6) { return new AdvancedDelegateP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P6 p6, P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G6(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate4!(R, P7, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P7 p7) { return new AdvancedDelegateP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P7 p7, P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P7 p7, P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G7(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate3!(R, P8, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate2!(R, P9, P10) opCall(P8 p8) { return new AdvancedDelegateP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P8 p8, P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P8 p8, P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G8(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate2!(R, P9, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval(P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate1!(R, P10) opCall(P9 p9) { return new AdvancedDelegateP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P9 p9, P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G9(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate1!(R, P10)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; }
    R Eval(P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate0!(R) opCall(P10 p10) { return new AdvancedDelegateP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedDelegateP10G10(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate0!(R)
{
    alias R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;
    P10 p10;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; this.p10 = p10; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

