<?php

    $nparams = 10;
    
    function paramtypenamelist($n) { $s=array();for($i=1;$i<=$n;$i++)$s[]="P$i";return $s; }
    function paramwithtypelist($n) { $s=array();for($i=1;$i<=$n;$i++)$s[]="P$i p$i";return $s; }
    function paramlist($n) { $s=array();for($i=1;$i<=$n;$i++)$s[]="p$i";return $s; }
    
    $adg_bases = array();
    $adg_delegate = array();
    $adg_function = array();
    $adg_aliases = array();
    $adg_helpers = array();
    
    $paramtypenames = array();
    
    // $i = number of total parameters    
    for ($i = 0; $i <= $nparams; $i++)
    {
        // List of P1, P2, ...
        $ptnl = paramtypenamelist($i);        
        // List of P1 p1, P2 p2, ...
        $pwtl = paramwithtypelist($i);
        // List of p1, p2, ...
        $pl = paramlist($i);
        
        // Same as above, comma separated strings
        $ptnls = join(", ", $ptnl);
        $pwtls = join(", ", $pwtl);
        $pls = join(", ", $pl);
        
        // Same as above, including return type "R"
        if ($i == 0) $ptnlsr = "R"; else $ptnlsr = "R, ".$ptnls;
        
        if ($i == 0) $givemtd = ""; else $givemtd = " ";
        
        $class =    "class AdvancedDelegate{$i}({$ptnlsr})\n".
                    "{\n".
                    "    abstract R Eval({$ptnls});\n";
        // $g = number of parameters given by opCall
        $typelist = "P1";
        $freelist = $ptnl;
        for ($g = 1; $g <= $i; $g++)
        {
            array_shift($freelist);
            $aparms = "R";
            if (count($freelist) > 0)
                $aparms .= ", ".join(", ", $freelist);
            $class .=
                    "    abstract AdvancedDelegate".($i-$g)."!({$aparms}) opCall({$typelist});\n";
            $typelist .= ", P".($g+1);
        }
        $class .=   "}\n";
        $adg_bases[] = $class;
        $adg_aliases[] = "alias AdvancedDelegate{$i} ADG{$i};";
                
        $adg_helpers[] =    "AdvancedDelegate{$i}!({$ptnlsr}) AdvancedDelegate({$ptnlsr}) (R delegate({$ptnls}) dg)\n".
                            "{\n".
                            "    return new AdvancedDelegateP{$i}G0!({$ptnlsr})(dg);\n".
                            "}\n";

        $adg_helpers[] =    "AdvancedDelegate{$i}!({$ptnlsr}) AdvancedFunction({$ptnlsr}) (R function({$ptnls}) dg)\n".
                            "{\n".
                            "    return new AdvancedFunctionP{$i}G0!({$ptnlsr})(dg);\n".
                            "}\n";
                
        // $j = number of given parameters
        for ($j = 0; $j <= $i; $j++)
        {           
            // List of P3, P4, ... = Parameters minus those given in the adg
            $ptnlmj = $ptnl; for ($k = 1; $k <= $j; $k++) array_shift($ptnlmj);
            $ptnlsmj = join(", ", $ptnlmj);
            if (count($ptnlmj) > 0) $ptnlsrmj = "R, ".$ptnlsmj; else $ptnlsrmj = "R";
            $pwtlmj = $pwtl; for ($k = 1; $k <= $j; $k++) array_shift($pwtlmj);
            $pwtlsmj = join(", ", $pwtlmj);
            $ptnlmjm1 = $ptnlmj; array_shift($ptnlmjm1);
            $ptnlsmjm1 = join(", ", $ptnlmjm1);
            if (count($ptnlmjm1) > 0) $ptnlsrmjm1 = "R, ".$ptnlsmjm1; else $ptnlsrmjm1 = "R";
            
            // For each given paramater, add ", Px px" to the constructors paramlist and " this.px = px;" to the
            // constructors implementation. Additionally we build up a string needed for the "Give" call.
            $cparamlist = "DG x";
            $cimplementation = "dg = x;";
            for ($k = 1; $k <= $j; $k++)
            {
                $cparamlist .= ", P{$k} p{$k}";
                $cimplementation .= " this.p{$k} = p{$k};";
            }
            
            // One template for a "delegate"
            $class =        "class AdvancedDelegateP{$i}G{$j}({$ptnlsr}) : AdvancedDelegate".($i-$j)."!({$ptnlsrmj})\n".
                            "{\n".
                            "    alias R delegate($ptnls) DG;\n".
                            "    DG dg;\n";
            for ($k = 1; $k <= $j; $k++)
                $class .=   "    P{$k} p{$k};\n";
            $class .=   "\n";
            $class .=       "    this({$cparamlist}) { {$cimplementation} }\n".
                            "    R Eval({$pwtlsmj}) { return dg({$pls}); }\n";
            // $g = number of parameters given by opCall
            $typelist = "P".($j+1)." p".($j+1);
            $freelist = $ptnlmj;
            $givelist = "dg";
            for ($n = 1; $n <= $j+1; $n++) $givelist .= ", p$n";
            for ($g = 1; $g <= ($i-$j); $g++)
            {
                array_shift($freelist);
                $aparms = "R";
                if (count($freelist) > 0)
                    $aparms .= ", ".join(", ", $freelist);
                $class .=   "    AdvancedDelegate".($i-$j-$g)."!({$aparms}) opCall({$typelist}) { return new AdvancedDelegateP{$i}G".($j+$g)."!({$ptnlsr})({$givelist}); }\n";
                $typelist .= ", P".($j+$g+1)." p".($j+$g+1);
                $givelist .= ", p".($j+$g+1);
            }
            $class .=       "}\n";
            // Add an alias for short naming
            $adg_delegate[] = $class;
            $adg_aliases[] = "alias AdvancedDelegateP{$i}G{$j} ADG{$i}_{$j};";

            // And one template for a "function pointer"
            $class =        "class AdvancedFunctionP{$i}G{$j}({$ptnlsr}) : AdvancedDelegate".($i-$j)."!({$ptnlsrmj})\n".
                            "{\n".
                            "    alias R function($ptnls) DG;\n".
                            "    DG dg;\n";
            for ($k = 1; $k <= $j; $k++)
                $class .=   "    P{$k} p{$k};\n";
            $class .=   "\n";
            $class .=       "    this({$cparamlist}) { {$cimplementation} }\n".
                            "    R Eval({$pwtlsmj}) { return dg({$pls}); }\n";
            // $g = number of parameters given by opCall
            $typelist = "P".($j+1)." p".($j+1);
            $freelist = $ptnlmj;
            $givelist = "dg";
            for ($n = 1; $n <= $j+1; $n++) $givelist .= ", p$n";
            for ($g = 1; $g <= ($i-$j); $g++)
            {
                array_shift($freelist);
                $aparms = "R";
                if (count($freelist) > 0)
                    $aparms .= ", ".join(", ", $freelist);
                $class .=   "    AdvancedDelegate".($i-$j-$g)."!({$aparms}) opCall({$typelist}) { return new AdvancedFunctionP{$i}G".($j+$g)."!({$ptnlsr})({$givelist}); }\n";
                $typelist .= ", P".($j+$g+1)." p".($j+$g+1);
                $givelist .= ", p".($j+$g+1);
            }
            $class .=       "}\n";
            // Add an alias for short naming
            $adg_function[] = $class;
            $adg_aliases[] = "alias AdvancedFunctionP{$i}G{$j} AFU{$i}_{$j};";
        }
    }

    $fp = fopen("base.d", "w");
    fwrite($fp, "\n");
    fwrite($fp, "module advanceddelegate.base;\n");
    fwrite($fp, "\n");
    foreach ($adg_bases as $s) fwrite($fp, "$s\n");
    fclose($fp);

    $fp = fopen("adelegate.d", "w");
    fwrite($fp, "\n");
    fwrite($fp, "module advanceddelegate.adelegate;\n");
    fwrite($fp, "\n");
    fwrite($fp, "private import advanceddelegate.base;\n");
    fwrite($fp, "\n");
    foreach ($adg_delegate as $s) fwrite($fp, "$s\n");
    fclose($fp);
    
    $fp = fopen("afunction.d", "w");
    fwrite($fp, "\n");
    fwrite($fp, "module advanceddelegate.afunction;\n");
    fwrite($fp, "\n");
    fwrite($fp, "private import advanceddelegate.base;\n");
    fwrite($fp, "\n");
    foreach ($adg_function as $s) fwrite($fp, "$s\n");
    fclose($fp);

    $fp = fopen("helpers.d", "w");
    fwrite($fp, "\n");
    fwrite($fp, "module advanceddelegate.helpers;\n");
    fwrite($fp, "\n");
    fwrite($fp, "private import advanceddelegate.base;\n");
    fwrite($fp, "private import advanceddelegate.adelegate;\n");
    fwrite($fp, "private import advanceddelegate.afunction;\n");
    fwrite($fp, "\n");
    foreach ($adg_helpers as $s) fwrite($fp, "$s\n");
    fclose($fp);

    $fp = fopen("all.d", "w");
    fwrite($fp, "\n");
    fwrite($fp, "module advanceddelegate.all;\n");
    fwrite($fp, "\n");
    fwrite($fp, "import advanceddelegate.base;\n");
    fwrite($fp, "import advanceddelegate.adelegate;\n");
    fwrite($fp, "import advanceddelegate.afunction;\n");
    fwrite($fp, "import advanceddelegate.helpers;\n");
    fwrite($fp, "\n");
    foreach ($adg_aliases as $s) fwrite($fp, "$s\n");
    fclose($fp);

?>