
module advanceddelegate.afunction;

private import advanceddelegate.base;

class AdvancedFunctionP0G0(R) : AdvancedDelegate0!(R)
{
    alias R function() DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval() { return dg(); }
}

class AdvancedFunctionP1G0(R, P1) : AdvancedDelegate1!(R, P1)
{
    alias R function(P1) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1) { return dg(p1); }
    AdvancedDelegate0!(R) opCall(P1 p1) { return new AdvancedFunctionP1G1!(R, P1)(dg, p1); }
}

class AdvancedFunctionP1G1(R, P1) : AdvancedDelegate0!(R)
{
    alias R function(P1) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval() { return dg(p1); }
}

class AdvancedFunctionP2G0(R, P1, P2) : AdvancedDelegate2!(R, P1, P2)
{
    alias R function(P1, P2) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2) { return dg(p1, p2); }
    AdvancedDelegate1!(R, P2) opCall(P1 p1) { return new AdvancedFunctionP2G1!(R, P1, P2)(dg, p1); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP2G2!(R, P1, P2)(dg, p1, p2); }
}

class AdvancedFunctionP2G1(R, P1, P2) : AdvancedDelegate1!(R, P2)
{
    alias R function(P1, P2) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2) { return dg(p1, p2); }
    AdvancedDelegate0!(R) opCall(P2 p2) { return new AdvancedFunctionP2G2!(R, P1, P2)(dg, p1, p2); }
}

class AdvancedFunctionP2G2(R, P1, P2) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval() { return dg(p1, p2); }
}

class AdvancedFunctionP3G0(R, P1, P2, P3) : AdvancedDelegate3!(R, P1, P2, P3)
{
    alias R function(P1, P2, P3) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate2!(R, P2, P3) opCall(P1 p1) { return new AdvancedFunctionP3G1!(R, P1, P2, P3)(dg, p1); }
    AdvancedDelegate1!(R, P3) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP3G2!(R, P1, P2, P3)(dg, p1, p2); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedFunctionP3G1(R, P1, P2, P3) : AdvancedDelegate2!(R, P2, P3)
{
    alias R function(P1, P2, P3) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate1!(R, P3) opCall(P2 p2) { return new AdvancedFunctionP3G2!(R, P1, P2, P3)(dg, p1, p2); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedFunctionP3G2(R, P1, P2, P3) : AdvancedDelegate1!(R, P3)
{
    alias R function(P1, P2, P3) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3) { return dg(p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P3 p3) { return new AdvancedFunctionP3G3!(R, P1, P2, P3)(dg, p1, p2, p3); }
}

class AdvancedFunctionP3G3(R, P1, P2, P3) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval() { return dg(p1, p2, p3); }
}

class AdvancedFunctionP4G0(R, P1, P2, P3, P4) : AdvancedDelegate4!(R, P1, P2, P3, P4)
{
    alias R function(P1, P2, P3, P4) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P2, P3, P4) opCall(P1 p1) { return new AdvancedFunctionP4G1!(R, P1, P2, P3, P4)(dg, p1); }
    AdvancedDelegate2!(R, P3, P4) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP4G2!(R, P1, P2, P3, P4)(dg, p1, p2); }
    AdvancedDelegate1!(R, P4) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedFunctionP4G1(R, P1, P2, P3, P4) : AdvancedDelegate3!(R, P2, P3, P4)
{
    alias R function(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P3, P4) opCall(P2 p2) { return new AdvancedFunctionP4G2!(R, P1, P2, P3, P4)(dg, p1, p2); }
    AdvancedDelegate1!(R, P4) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedFunctionP4G2(R, P1, P2, P3, P4) : AdvancedDelegate2!(R, P3, P4)
{
    alias R function(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P4) opCall(P3 p3) { return new AdvancedFunctionP4G3!(R, P1, P2, P3, P4)(dg, p1, p2, p3); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedFunctionP4G3(R, P1, P2, P3, P4) : AdvancedDelegate1!(R, P4)
{
    alias R function(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4) { return dg(p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P4 p4) { return new AdvancedFunctionP4G4!(R, P1, P2, P3, P4)(dg, p1, p2, p3, p4); }
}

class AdvancedFunctionP4G4(R, P1, P2, P3, P4) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval() { return dg(p1, p2, p3, p4); }
}

class AdvancedFunctionP5G0(R, P1, P2, P3, P4, P5) : AdvancedDelegate5!(R, P1, P2, P3, P4, P5)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P2, P3, P4, P5) opCall(P1 p1) { return new AdvancedFunctionP5G1!(R, P1, P2, P3, P4, P5)(dg, p1); }
    AdvancedDelegate3!(R, P3, P4, P5) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP5G2!(R, P1, P2, P3, P4, P5)(dg, p1, p2); }
    AdvancedDelegate2!(R, P4, P5) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP5G1(R, P1, P2, P3, P4, P5) : AdvancedDelegate4!(R, P2, P3, P4, P5)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P3, P4, P5) opCall(P2 p2) { return new AdvancedFunctionP5G2!(R, P1, P2, P3, P4, P5)(dg, p1, p2); }
    AdvancedDelegate2!(R, P4, P5) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP5G2(R, P1, P2, P3, P4, P5) : AdvancedDelegate3!(R, P3, P4, P5)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P4, P5) opCall(P3 p3) { return new AdvancedFunctionP5G3!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3); }
    AdvancedDelegate1!(R, P5) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP5G3(R, P1, P2, P3, P4, P5) : AdvancedDelegate2!(R, P4, P5)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P5) opCall(P4 p4) { return new AdvancedFunctionP5G4!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP5G4(R, P1, P2, P3, P4, P5) : AdvancedDelegate1!(R, P5)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5) { return dg(p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P5 p5) { return new AdvancedFunctionP5G5!(R, P1, P2, P3, P4, P5)(dg, p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP5G5(R, P1, P2, P3, P4, P5) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval() { return dg(p1, p2, p3, p4, p5); }
}

class AdvancedFunctionP6G0(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate6!(R, P1, P2, P3, P4, P5, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate5!(R, P2, P3, P4, P5, P6) opCall(P1 p1) { return new AdvancedFunctionP6G1!(R, P1, P2, P3, P4, P5, P6)(dg, p1); }
    AdvancedDelegate4!(R, P3, P4, P5, P6) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP6G2!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G1(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate5!(R, P2, P3, P4, P5, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate4!(R, P3, P4, P5, P6) opCall(P2 p2) { return new AdvancedFunctionP6G2!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G2(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate4!(R, P3, P4, P5, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P4, P5, P6) opCall(P3 p3) { return new AdvancedFunctionP6G3!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3); }
    AdvancedDelegate2!(R, P5, P6) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G3(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate3!(R, P4, P5, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P5, P6) opCall(P4 p4) { return new AdvancedFunctionP6G4!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4); }
    AdvancedDelegate1!(R, P6) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G4(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate2!(R, P5, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P6) opCall(P5 p5) { return new AdvancedFunctionP6G5!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G5(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate1!(R, P6)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6) { return dg(p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P6 p6) { return new AdvancedFunctionP6G6!(R, P1, P2, P3, P4, P5, P6)(dg, p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP6G6(R, P1, P2, P3, P4, P5, P6) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5, P6) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6); }
}

class AdvancedFunctionP7G0(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate7!(R, P1, P2, P3, P4, P5, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate6!(R, P2, P3, P4, P5, P6, P7) opCall(P1 p1) { return new AdvancedFunctionP7G1!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1); }
    AdvancedDelegate5!(R, P3, P4, P5, P6, P7) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP7G2!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G1(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate6!(R, P2, P3, P4, P5, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate5!(R, P3, P4, P5, P6, P7) opCall(P2 p2) { return new AdvancedFunctionP7G2!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G2(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate5!(R, P3, P4, P5, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P3 p3) { return new AdvancedFunctionP7G3!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G3(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate4!(R, P4, P5, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate3!(R, P5, P6, P7) opCall(P4 p4) { return new AdvancedFunctionP7G4!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4); }
    AdvancedDelegate2!(R, P6, P7) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G4(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate3!(R, P5, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P6, P7) opCall(P5 p5) { return new AdvancedFunctionP7G5!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate1!(R, P7) opCall(P5 p5, P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G5(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate2!(R, P6, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P7) opCall(P6 p6) { return new AdvancedFunctionP7G6!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G6(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate1!(R, P7)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7) { return dg(p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P7 p7) { return new AdvancedFunctionP7G7!(R, P1, P2, P3, P4, P5, P6, P7)(dg, p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP7G7(R, P1, P2, P3, P4, P5, P6, P7) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7); }
}

class AdvancedFunctionP8G0(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate8!(R, P1, P2, P3, P4, P5, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate7!(R, P2, P3, P4, P5, P6, P7, P8) opCall(P1 p1) { return new AdvancedFunctionP8G1!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1); }
    AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP8G2!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G1(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate7!(R, P2, P3, P4, P5, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8) opCall(P2 p2) { return new AdvancedFunctionP8G2!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G2(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P3 p3) { return new AdvancedFunctionP8G3!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G3(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate5!(R, P4, P5, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P4 p4) { return new AdvancedFunctionP8G4!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G4(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate4!(R, P5, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate3!(R, P6, P7, P8) opCall(P5 p5) { return new AdvancedFunctionP8G5!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate2!(R, P7, P8) opCall(P5 p5, P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G5(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate3!(R, P6, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate2!(R, P7, P8) opCall(P6 p6) { return new AdvancedFunctionP8G6!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate1!(R, P8) opCall(P6 p6, P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G6(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate2!(R, P7, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P8) opCall(P7 p7) { return new AdvancedFunctionP8G7!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G7(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate1!(R, P8)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8) { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P8 p8) { return new AdvancedFunctionP8G8!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP8G8(R, P1, P2, P3, P4, P5, P6, P7, P8) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8); }
}

class AdvancedFunctionP9G0(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate8!(R, P2, P3, P4, P5, P6, P7, P8, P9) opCall(P1 p1) { return new AdvancedFunctionP9G1!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1); }
    AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP9G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G1(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate8!(R, P2, P3, P4, P5, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9) opCall(P2 p2) { return new AdvancedFunctionP9G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G2(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P3 p3) { return new AdvancedFunctionP9G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G3(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P4 p4) { return new AdvancedFunctionP9G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G4(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate5!(R, P5, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P5 p5) { return new AdvancedFunctionP9G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P5 p5, P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G5(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate4!(R, P6, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate3!(R, P7, P8, P9) opCall(P6 p6) { return new AdvancedFunctionP9G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate2!(R, P8, P9) opCall(P6 p6, P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G6(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate3!(R, P7, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate2!(R, P8, P9) opCall(P7 p7) { return new AdvancedFunctionP9G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate1!(R, P9) opCall(P7 p7, P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G7(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate2!(R, P8, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8, P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate1!(R, P9) opCall(P8 p8) { return new AdvancedFunctionP9G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate0!(R) opCall(P8 p8, P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G8(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate1!(R, P9)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval(P9 p9) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P9 p9) { return new AdvancedFunctionP9G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP9G9(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9); }
}

class AdvancedFunctionP10G0(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;

    this(DG x) { dg = x; }
    R Eval(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate9!(R, P2, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1) { return new AdvancedFunctionP10G1!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1); }
    AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2) { return new AdvancedFunctionP10G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3) { return new AdvancedFunctionP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G1(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate9!(R, P2, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;

    this(DG x, P1 p1) { dg = x; this.p1 = p1; }
    R Eval(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P2 p2) { return new AdvancedFunctionP10G2!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3) { return new AdvancedFunctionP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4) { return new AdvancedFunctionP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G2(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;

    this(DG x, P1 p1, P2 p2) { dg = x; this.p1 = p1; this.p2 = p2; }
    R Eval(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P3 p3) { return new AdvancedFunctionP10G3!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P3 p3, P4 p4) { return new AdvancedFunctionP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5) { return new AdvancedFunctionP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G3(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;

    this(DG x, P1 p1, P2 p2, P3 p3) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; }
    R Eval(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P4 p4) { return new AdvancedFunctionP10G4!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P4 p4, P5 p5) { return new AdvancedFunctionP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P4 p4, P5 p5, P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G4(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; }
    R Eval(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P5 p5) { return new AdvancedFunctionP10G5!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P5 p5, P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P5 p5, P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P5 p5, P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G5(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate5!(R, P6, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; }
    R Eval(P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P6 p6) { return new AdvancedFunctionP10G6!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P6 p6, P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P6 p6, P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P6 p6, P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G6(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate4!(R, P7, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; }
    R Eval(P7 p7, P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate3!(R, P8, P9, P10) opCall(P7 p7) { return new AdvancedFunctionP10G7!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7); }
    AdvancedDelegate2!(R, P9, P10) opCall(P7 p7, P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P7 p7, P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P7 p7, P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G7(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate3!(R, P8, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; }
    R Eval(P8 p8, P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate2!(R, P9, P10) opCall(P8 p8) { return new AdvancedFunctionP10G8!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8); }
    AdvancedDelegate1!(R, P10) opCall(P8 p8, P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P8 p8, P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G8(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate2!(R, P9, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; }
    R Eval(P9 p9, P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate1!(R, P10) opCall(P9 p9) { return new AdvancedFunctionP10G9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9); }
    AdvancedDelegate0!(R) opCall(P9 p9, P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G9(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate1!(R, P10)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; }
    R Eval(P10 p10) { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
    AdvancedDelegate0!(R) opCall(P10 p10) { return new AdvancedFunctionP10G10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

class AdvancedFunctionP10G10(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) : AdvancedDelegate0!(R)
{
    alias R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) DG;
    DG dg;
    P1 p1;
    P2 p2;
    P3 p3;
    P4 p4;
    P5 p5;
    P6 p6;
    P7 p7;
    P8 p8;
    P9 p9;
    P10 p10;

    this(DG x, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6, P7 p7, P8 p8, P9 p9, P10 p10) { dg = x; this.p1 = p1; this.p2 = p2; this.p3 = p3; this.p4 = p4; this.p5 = p5; this.p6 = p6; this.p7 = p7; this.p8 = p8; this.p9 = p9; this.p10 = p10; }
    R Eval() { return dg(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10); }
}

